vddk: advise user on obscure thumbprint mismatch error condition
[nbdkit.git] / tests / test-null-extents.sh
blob0212702278586ddac05a91a4c45f9bfec675c053
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2018-2020 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires_run
38 requires jq --version
39 requires qemu-img --version
40 requires qemu-img map --help
42 out="test-null-extents.out"
43 expected="test-null-extents.expected"
44 files="$out $expected"
45 rm -f $files
46 cleanup_fn rm -f $files
48 do_test ()
50 # We use jq to normalize the output and convert it to plain text.
51 nbdkit -U - \
52 null "$1" \
53 --run 'qemu-img map -f raw --output=json $nbd' |
54 jq -c '.[] | {start:.start, length:.length, data:.data, zero:.zero}' \
55 > $out
56 if ! cmp $out $expected; then
57 echo "$0: output did not match expected data"
58 echo "expected:"
59 cat $expected
60 echo "output:"
61 cat $out
62 exit 1
66 # Non-zero sized null disk.
67 cat > $expected <<'EOF'
68 {"start":0,"length":65536,"data":false,"zero":true}
69 EOF
70 do_test 64K
72 # Zero sized null disk.
73 cat > $expected <<'EOF'
74 {"start":0,"length":0,"data":false,"zero":false}
75 EOF
76 do_test 0